searchNodes=[{"doc":"MockeryExtras.Given provides a simple way to stub function calls.use Given given Map.get(%{}, :key), return: &quot;5&quot; given Map.get(@any, :key), return: &quot;5&quot;There is also support for writing your own macros.","ref":"MockeryExtras.html","title":"MockeryExtras","type":"module"},{"doc":"This module provides a pretty notation for a common case that's not gracefully handled by Mockery. Here is how you instruct Mockery to return a specific value when a function is called with a specific set of arguments:use MockeryExtras.Given given Map.get(%{}, :key), return: &quot;5&quot;Note that the first argument to given looks like an ordinary function call.It is also common to have a &quot;don't care&quot; argument, like this:given Map.get(@any, :key), return: &quot;5&quot;See given/2 for more.","ref":"MockeryExtras.Given.html","title":"MockeryExtras.Given","type":"module"},{"doc":"The guts of given/2 for use in your own macros.This function is convenient when you want to create a number of stubs at once. For example, suppose the RunningExample module has several single-argument getters. A stub macro can be more compact than several givens:stub( original_params: input, format: :phoenix, neighborhood: %{een(b: Module) =&gt; %{id: 383}})stub can be written like this:defmacro stub(kws) do for {key, val} &lt;- kws do Given.expand(RunningExample, [{key, 1}], [:running], val) end endWhen calling expand(module_alias, name_and_arity, arglist_spec, return_value), know that:module_alias can be a simple atom, like RunningExample, which is an alias for EctoTestDSL.Run.RunningExample. More generally, it can be the :__aliases__ value from Macro.decompose_call/1. name_and_arity is a function name and arity pair of the form [get: 3].arglist_spec is a list of values like [5, @any].return_value is any value.","ref":"MockeryExtras.Given.html#expand/4","title":"MockeryExtras.Given.expand/4","type":"function"},{"doc":"Takes what looks like a function call, plus a return value, and arranges that such a function call will return the given value whenever it's made at a &quot;seam&quot; marked with Mockery.mockable/1. # Code: ... mockable(Schema).changeset(struct, params) ... # Test: given Schema.changeset(%Schema{}, %{age: &quot;3&quot;}), return: %Changeset{...}The function's arguments and return value can be constants, as shown above, or they can be calculations or variables. That can be helpful when the given appears in a test helper:def helper(params, cast_value, something_else) do ... given Schema.changeset(%Schema{}, params), return: cast_value ... assert ... endA function argument can be the special value @any (defined when the module is used). That's useful when the argument is irrelevant and you don't want to have to type it out: given Schema.changeset(@any, params), return: cast_value@any expands to a function whose value is always true. More generally, any function used as an argument is not matched with equality. Instead, the call-time value is passed to the function, which should return a truthy value to indicate a match. So you can do this: given Module.f(5, &amp;even/1), return: 8Notes:You can provide return values for many arglist values. given Module.f(5, &amp;even/1), return: 8 given Module.f(6, @any), return: 9If there's more than one match, the first is used.If the same arglist is given twice, the second replaces the first. This is useful for setup methods:def setup do given RunningExample.params(:a_runnable), return: %{} ... test &quot;...&quot; given RunningExample.params(:a_runnable), return: %{&quot;a&quot; =&gt; &quot;1&quot;} assert Steps.runnable(:a_runnable) == %{a: 1} endIf a function has a given value for one or more arglists, but none matched, an error is thrown.","ref":"MockeryExtras.Given.html#given/2","title":"MockeryExtras.Given.given/2","type":"macro"},{"doc":"This shows (as with IO.inspect) all the existing stubs.The format is not pretty.","ref":"MockeryExtras.Given.html#inspect/0","title":"MockeryExtras.Given.inspect/0","type":"function"}]